#include<bits/stdc++.h>
using namespace std;
void test()
{
    int n;
    cin>>n;
    pair<int,int> a[n];
    int sum=0;
    for(int i=0;i<n;i++){
        cin>>a[i].first;
        a[i].second=i;
    }
    sort(a,a+n);
    bool w=true,x=true,y=true;
    for(int i=0;i<n;i+=2){
        if(a[i].first!=a[i+1].first) w=false;
    }
    for(int i=0;i<n;i++){
        if(a[i].first!=(1<<i)) x=false;
        if(a[i].first!=i+1) y=false;
    }
    if(w){
        for(int i=0;i<n;i+=2){
            cout<<a[i].second<<" ";
        }
    }
    else if(x){
        cout<<n-1;
    }
    else if(y){
        if(n%4==0){
            for(int i=0;i<n/2;i++){
                cout<<i<<" "<<n-i-1<<" ";
            }
        }
        else{
            int r=n%4;
            for(int i=r;i<(n-r)/2+r;i++){
                cout<<i<<" "<<n-i-1<<" ";
            }
            if(r==1){
                cout<<0;
            }
            if(r==2){
                cout<<1;
            }
            if(r==3){
                cout<<0<<" "<<1;
            }
        }
    }

}
int main()
{
    int t;
    cin>>t;
    while(t--){
        test();
    }
}
